(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common/http'), require('@angular/core'), require('rxjs/operators'), require('@angular/platform-browser'), require('rxjs'), require('@angular/router'), require('@bravobit/bb-foundation/storage'), require('@bravobit/bb-foundation'), require('@bravobit/bb-foundation/http')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/auth', ['exports', '@angular/common/http', '@angular/core', 'rxjs/operators', '@angular/platform-browser', 'rxjs', '@angular/router', '@bravobit/bb-foundation/storage', '@bravobit/bb-foundation', '@bravobit/bb-foundation/http'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit["bb-foundation"] = global.bravobit["bb-foundation"] || {}, global.bravobit["bb-foundation"].auth = {}), global.ng.common.http, global.ng.core, global.rxjs.operators, global.ng.platformBrowser, global.rxjs, global.ng.router, global.bravobit["bb-foundation"].storage, global.bravobit["bb-foundation"], global.bravobit["bb-foundation"].http));
})(this, (function (exports, i4, i0, operators, i6, rxjs, router, i1, i3, i7) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i6__namespace = /*#__PURE__*/_interopNamespace(i6);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i7__namespace = /*#__PURE__*/_interopNamespace(i7);

    var AuthConfig = /** @class */ (function () {
        function AuthConfig() {
        }
        return AuthConfig;
    }());

    var USE_AUTHORIZATION = new i4.HttpContextToken(function () { return true; });

    var JwtHelper = /** @class */ (function () {
        function JwtHelper() {
            var _this = this;
            this.baseDecodeUnicode = function (value) {
                return decodeURIComponent(atob(value).replace(/(.)/g, function (_, p) {
                    var code = p.charCodeAt(0).toString(16).toUpperCase();
                    if (code.length < 2) {
                        code = '0' + code;
                    }
                    return '%' + code;
                }));
            };
            this.parse = function (data) {
                return {
                    id: data['iss'] || null,
                    type: data['typ'] || null,
                    audience: data['aud'] || null,
                    issuer: data['iss'] || null,
                    subject: data['sub'] || null,
                    role: data['role'] || null,
                    notValidBefore: _this.parseDate(data['nbf']),
                    expiresAt: _this.parseDate(data['exp']),
                    issuedAt: _this.parseDate(data['iat'])
                };
            };
            this.parseDate = function (epochInSeconds) {
                if (!epochInSeconds || epochInSeconds <= 0) {
                    return null;
                }
                return new Date(epochInSeconds * 1000);
            };
        }
        JwtHelper.prototype.decode = function (token) {
            try {
                if (token === null || token === undefined) {
                    return null;
                }
                var json = JSON.parse(this.urlDecode(token.split('.')[1]));
                return this.parse(json);
            }
            catch (_a) {
                return null;
            }
        };
        JwtHelper.prototype.urlDecode = function (token) {
            var value = token || '';
            var output = value
                .replace(/-/g, '+')
                .replace(/_/g, '/');
            switch (output.length % 4) {
                case 0:
                    break;
                case 2:
                    output += '==';
                    break;
                case 3:
                    output += '=';
                    break;
                default:
                    throw 'Illegal base64url string!';
            }
            try {
                return this.baseDecodeUnicode(output);
            }
            catch (_a) {
                return atob(output);
            }
        };
        return JwtHelper;
    }());

    var AuthMapper = /** @class */ (function () {
        function AuthMapper() {
            // Routes.
            this.me = 'auth/me';
            this.register = 'auth/register';
            this.resendCode = 'auth/resend';
            this.logout = 'auth/logout';
            this.refresh = 'auth/refresh';
            this.requestPassword = 'auth/reset';
            this.resetPassword = 'auth/reset-password';
        }
        AuthMapper.prototype.role = function (data) {
            return (data && data.role) || null;
        };
        AuthMapper.prototype.toRegister = function (data) {
            // Retrieve the params.
            var token = data.token, refresh_token = data.refresh_token, user = data.user;
            // Map the data to the correct format.
            return { accessToken: token, refreshToken: refresh_token, user: user };
        };
        AuthMapper.prototype.toRefresh = function (data) {
            // Retrieve the params.
            var token = data.token, refresh_token = data.refresh_token;
            // Map the data to the correct format.
            return { accessToken: token, refreshToken: refresh_token };
        };
        return AuthMapper;
    }());
    AuthMapper.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthMapper, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    AuthMapper.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthMapper });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthMapper, decorators: [{
                type: i0.Injectable
            }] });

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var AuthVerifyProvider = /** @class */ (function () {
        function AuthVerifyProvider(_code, _verifyToken, _endpoint) {
            this._code = _code;
            this._verifyToken = _verifyToken;
            this._endpoint = _endpoint;
        }
        AuthVerifyProvider.prototype.authenticate = function (httpClient) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, token, refresh_token, user;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, httpClient.post(this._endpoint, {
                                token: this._code,
                                verify_token: this._verifyToken
                            }).toPromise()];
                        case 1:
                            _a = _b.sent(), token = _a.token, refresh_token = _a.refresh_token, user = _a.user;
                            // Map the data to the correct format.
                            return [2 /*return*/, { accessToken: token, refreshToken: refresh_token, user: user }];
                    }
                });
            });
        };
        return AuthVerifyProvider;
    }());

    var AuthEmailProvider = /** @class */ (function () {
        function AuthEmailProvider(_email, _password, _endpoint) {
            this._email = _email;
            this._password = _password;
            this._endpoint = _endpoint;
        }
        AuthEmailProvider.prototype.authenticate = function (httpClient) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, token, refresh_token, user, provider, verify_token;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4 /*yield*/, httpClient.post(this._endpoint, {
                                email: this._email,
                                password: this._password
                            }).toPromise()];
                        case 1:
                            _a = _b.sent(), token = _a.token, refresh_token = _a.refresh_token, user = _a.user, provider = _a.provider, verify_token = _a.verify_token;
                            // Map the data to the correct format.
                            return [2 /*return*/, {
                                    accessToken: token,
                                    refreshToken: refresh_token,
                                    user: user,
                                    provider: provider,
                                    verifyToken: verify_token
                                }];
                    }
                });
            });
        };
        return AuthEmailProvider;
    }());

    var AuthSession = /** @class */ (function () {
        function AuthSession(options) {
            var _a, _b;
            // Readonly data.
            this._jwt = new JwtHelper();
            // Token strings.
            this._accessTokenString = null;
            this._refreshTokenString = null;
            // Token payloads.
            this._accessTokenPayload = null;
            this._refreshTokenPayload = null;
            // Private user data.
            this._user$ = new rxjs.BehaviorSubject(null);
            // Public user data.
            this.user = this._user$.pipe(operators.shareReplay(1));
            this.generateKey = function (applicationId, key) {
                return [applicationId, key].join('_');
            };
            this.isTokenValid = function (token) {
                var _a;
                if (!token) {
                    return false;
                }
                return ((_a = token === null || token === void 0 ? void 0 : token.expiresAt) === null || _a === void 0 ? void 0 : _a.getTime()) > Date.now();
            };
            var applicationId = (_a = options === null || options === void 0 ? void 0 : options.id) !== null && _a !== void 0 ? _a : 'ng';
            // Setting up the readonly storage keys.
            this._accessTokenStorageKey = this.generateKey(applicationId, 'au_act');
            this._refreshTokenStorageKey = this.generateKey(applicationId, 'au_rft');
            this._userStorageKey = this.generateKey(applicationId, 'au_usr');
            // Setting up the storage.
            this._storage = (_b = options === null || options === void 0 ? void 0 : options.storage) !== null && _b !== void 0 ? _b : null;
            // Init methods.
            this.restoreFromStorage();
        }
        Object.defineProperty(AuthSession.prototype, "accessToken", {
            get: function () {
                return this.isTokenValid(this._accessTokenPayload)
                    ? this._accessTokenString
                    : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AuthSession.prototype, "refreshToken", {
            get: function () {
                return this.isTokenValid(this.refreshTokenPayload)
                    ? this._refreshTokenString
                    : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AuthSession.prototype, "accessTokenPayload", {
            get: function () {
                var _a;
                return (_a = this._accessTokenPayload) !== null && _a !== void 0 ? _a : null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AuthSession.prototype, "refreshTokenPayload", {
            get: function () {
                var _a;
                return (_a = this._refreshTokenPayload) !== null && _a !== void 0 ? _a : null;
            },
            enumerable: false,
            configurable: true
        });
        AuthSession.prototype.authenticated = function () {
            return this.isTokenValid(this._accessTokenPayload) || this.isTokenValid(this._refreshTokenPayload);
        };
        AuthSession.prototype.setTokens = function (accessToken, refreshToken) {
            this.setAccessToken(accessToken);
            this.setRefreshToken(refreshToken);
            this.syncTokensInStorage();
        };
        AuthSession.prototype.setUser = function (user) {
            this._user$.next(user !== null && user !== void 0 ? user : null);
            this.syncUserInStorage();
        };
        AuthSession.prototype.clear = function () {
            this.setTokens(null, null);
            this.setUser(null);
        };
        AuthSession.prototype.restoreFromStorage = function () {
            if (!this._storage) {
                return;
            }
            // Set the access token.
            var accessToken = this._storage.get(this._accessTokenStorageKey);
            this.setAccessToken(accessToken);
            // Set the refresh token.
            var refreshToken = this._storage.get(this._refreshTokenStorageKey);
            this.setRefreshToken(refreshToken);
            // Set the user if we have any correct token payloads.
            if (this._accessTokenPayload || this._refreshTokenPayload) {
                var user = this._storage.get(this._userStorageKey);
                this._user$.next(user !== null && user !== void 0 ? user : null); // Note: just settings here instead of setUser() because of syncing to the storage.
            }
        };
        AuthSession.prototype.syncTokensInStorage = function () {
            var _a, _b;
            if (!this._storage) {
                return;
            }
            // Set the access token if completely valid.
            if (!!this.accessToken) {
                this._storage.set(this._accessTokenStorageKey, this._accessTokenString, {
                    expires: (_a = this._accessTokenPayload) === null || _a === void 0 ? void 0 : _a.expiresAt
                });
            }
            else {
                this._storage.remove(this._accessTokenStorageKey);
            }
            // Set the refresh token if completely valid.
            if (!!this.refreshToken) {
                this._storage.set(this._refreshTokenStorageKey, this._refreshTokenString, {
                    expires: (_b = this._refreshTokenPayload) === null || _b === void 0 ? void 0 : _b.expiresAt
                });
            }
            else {
                this._storage.remove(this._refreshTokenStorageKey);
            }
        };
        AuthSession.prototype.syncUserInStorage = function () {
            if (!this._storage) {
                return;
            }
            var user = this._user$.getValue();
            if (!user) {
                return this._storage.remove(this._userStorageKey);
            }
            var date = new Date();
            date.setFullYear(date.getFullYear() + 1);
            this._storage.set(this._userStorageKey, user, {
                expires: new Date(date.getTime())
            });
        };
        AuthSession.prototype.setAccessToken = function (value) {
            this._accessTokenString = value !== null && value !== void 0 ? value : null;
            this._accessTokenPayload = this._jwt.decode(this._accessTokenString);
        };
        AuthSession.prototype.setRefreshToken = function (value) {
            this._refreshTokenString = value !== null && value !== void 0 ? value : null;
            this._refreshTokenPayload = this._jwt.decode(this._refreshTokenString);
        };
        return AuthSession;
    }());

    var Auth = /** @class */ (function () {
        function Auth(_storage, _mapper, _injector, _platform, _httpClient, _config, _state, _httpConfig) {
            var _a, _b, _c;
            this._storage = _storage;
            this._mapper = _mapper;
            this._injector = _injector;
            this._platform = _platform;
            this._httpClient = _httpClient;
            this._config = _config;
            this._state = _state;
            this._httpConfig = _httpConfig;
            // Readonly data.
            this._authStateKey = i6.makeStateKey("bbAuthStateKey");
            this._httpAlias = (_b = (_a = this._httpConfig) === null || _a === void 0 ? void 0 : _a.defaultAlias) !== null && _b !== void 0 ? _b : null;
            this._refreshHandler = null;
            // Starting the new session.
            this.session = new AuthSession({
                id: (_c = this._config) === null || _c === void 0 ? void 0 : _c.applicationId,
                storage: this._storage.select(["cookie" /* Cookie */, "local" /* Local */])
            });
            this.user = this.session.user;
        }
        Auth.prototype.initialize = function () {
            var _this = this;
            return function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, _b, _c, _d, _e, _f, shouldBootstrap, user_1, user;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            shouldBootstrap = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.bootstrap) !== null && _b !== void 0 ? _b : true;
                            if (!shouldBootstrap) {
                                return [2 /*return*/, this.handleAutoRefreshing()];
                            }
                            // Only retrieve from the server when we are actually authenticated.
                            if (!this.session.authenticated()) {
                                return [2 /*return*/];
                            }
                            // Get the key from the server state.
                            if (this._state && ((_c = this._state) === null || _c === void 0 ? void 0 : _c.hasKey(this._authStateKey))) {
                                user_1 = (_e = (_d = this._state) === null || _d === void 0 ? void 0 : _d.get(this._authStateKey, null)) !== null && _e !== void 0 ? _e : null;
                                return [2 /*return*/, this.session.setUser(user_1)];
                            }
                            return [4 /*yield*/, this.me().pipe(operators.take(1)).toPromise()];
                        case 1:
                            user = _g.sent();
                            // Set the state if exists.
                            if (this._state) {
                                (_f = this._state) === null || _f === void 0 ? void 0 : _f.set(this._authStateKey, user !== null && user !== void 0 ? user : null);
                            }
                            // Save the user in the storage and handle auto refreshing.
                            this.session.setUser(user);
                            this.handleAutoRefreshing();
                            return [2 /*return*/];
                    }
                });
            }); };
        };
        Auth.prototype.me = function () {
            var url = this.getUrl('auth/me');
            return this._httpClient.get(url);
        };
        Auth.prototype.signIn = function (provider, as) {
            var _a, _b;
            return __awaiter(this, void 0, void 0, function () {
                var _c, accessToken, refreshToken, user, result, apiProvider, apiVerifyToken, availableProviders;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0: return [4 /*yield*/, provider.authenticate(this._httpClient)];
                        case 1:
                            _c = _g.sent(), accessToken = _c.accessToken, refreshToken = _c.refreshToken, user = _c.user, result = __rest(_c, ["accessToken", "refreshToken", "user"]);
                            // Check if the role matches.
                            if (as && !as.includes(this._mapper.role(user))) {
                                throw new Error('Invalid role.');
                            }
                            apiProvider = (_a = result === null || result === void 0 ? void 0 : result.provider) !== null && _a !== void 0 ? _a : null;
                            apiVerifyToken = (_b = result === null || result === void 0 ? void 0 : result.verifyToken) !== null && _b !== void 0 ? _b : null;
                            availableProviders = ['email', 'sms', 'totp'];
                            if (availableProviders.includes(apiProvider)) {
                                return [2 /*return*/, { user: user, provider: apiProvider, verifyToken: apiVerifyToken }];
                            }
                            // Set the tokens in storage.
                            this.setTokens(accessToken, refreshToken);
                            // Set the user in storage.
                            this.session.setUser(user);
                            // Return the user.
                            return [2 /*return*/, { user: user }];
                    }
                });
            });
        };
        Auth.prototype.signInWithEmail = function (email, password, as) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_g) {
                    url = this.getUrl('auth/login');
                    return [2 /*return*/, this.signIn(new AuthEmailProvider(email, password, url), as)];
                });
            });
        };
        Auth.prototype.signInWithVerifyCode = function (code, verifyToken) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_g) {
                    url = this.getUrl('auth/verify');
                    return [2 /*return*/, this.signIn(new AuthVerifyProvider(code, verifyToken, url))];
                });
            });
        };
        Auth.prototype.resendVerifyCode = function (verifyToken) {
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            url = this.getUrl('auth/resend');
                            return [4 /*yield*/, this._httpClient.post(url, {
                                    verify_token: verifyToken
                                }).toPromise()];
                        case 1: return [2 /*return*/, _g.sent()];
                    }
                });
            });
        };
        Auth.prototype.register = function (data, options) {
            return __awaiter(this, void 0, void 0, function () {
                var url, result, _g, accessToken, refreshToken, user;
                return __generator(this, function (_h) {
                    switch (_h.label) {
                        case 0:
                            url = this.getUrl('auth/register');
                            return [4 /*yield*/, this._httpClient
                                    .post(url, data, options)
                                    .toPromise()];
                        case 1:
                            result = _h.sent();
                            _g = this._mapper.toRegister(result), accessToken = _g.accessToken, refreshToken = _g.refreshToken, user = _g.user;
                            // Set the tokens in storage.
                            this.setTokens(accessToken, refreshToken);
                            // Set the user in storage.
                            this.session.setUser(user);
                            // Return the user.
                            return [2 /*return*/, user];
                    }
                });
            });
        };
        Auth.prototype.logout = function () {
            // If we don't have a refresh token just clear the session.
            // Note: We do this because else we try to invalidate
            // an "undefined" refresh token.
            var refreshToken = this.session.refreshToken;
            if (!refreshToken) {
                return this.session.clear();
            }
            // We do have a refresh token, so try to
            // invalidate it in the backend.
            try {
                var url = this.getUrl('auth/logout');
                this._httpClient.get(url, {
                    headers: { Authorization: refreshToken }
                }).toPromise().then(function (_) { return _; });
            }
            catch (_a) {
                // Do nothing because the tokens will be deleted anyways from the session.
            }
            // Delete the tokens from the session.
            return this.session.clear();
        };
        Auth.prototype.refresh = function () {
            var _this = this;
            var _a, _b;
            // If the refresh token does
            // not exist just return an observable of null.
            var refreshToken = this.session.refreshToken;
            if (!refreshToken) {
                return rxjs.of(null);
            }
            // Perform the refresh call.
            var scheme = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.scheme) !== null && _b !== void 0 ? _b : 'Bearer';
            var url = this.getUrl('auth/refresh');
            var context = new i4.HttpContext()
                .set(USE_AUTHORIZATION, false);
            return this._httpClient.get(url, {
                headers: { Authorization: scheme + " " + refreshToken },
                context: context
            }).pipe(operators.map(function (data) { return _this._mapper.toRefresh(data); }), operators.tap(function (_g) {
                var accessToken = _g.accessToken, refreshToken = _g.refreshToken;
                return _this.setTokens(accessToken, refreshToken);
            }), operators.map(function (_g) {
                var accessToken = _g.accessToken;
                return accessToken;
            }));
        };
        Auth.prototype.requestPassword = function (email, extraParams) {
            if (extraParams === void 0) { extraParams = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            url = this.getUrl('auth/reset');
                            return [4 /*yield*/, this._httpClient
                                    .post(url, Object.assign(Object.assign({}, extraParams), { email: email }))
                                    .toPromise()];
                        case 1: return [2 /*return*/, _g.sent()];
                    }
                });
            });
        };
        Auth.prototype.resetPassword = function (token, newPassword, extraParams) {
            if (extraParams === void 0) { extraParams = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            url = this.getUrl('auth/reset-password');
                            return [4 /*yield*/, this._httpClient
                                    .post(url, Object.assign(Object.assign({}, extraParams), { token: token, password: newPassword }))
                                    .toPromise()];
                        case 1: return [2 /*return*/, _g.sent()];
                    }
                });
            });
        };
        Auth.prototype.guard = function (type, redirectUrl) {
            var _a, _b, _c, _d, _e, _f;
            var newUrl = null;
            // Get the correct new url.
            switch (type) {
                case 'authenticated':
                    newUrl = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.loggedInUrl) !== null && _b !== void 0 ? _b : null;
                    break;
                case 'unauthenticated':
                    newUrl = (_d = (_c = this._config) === null || _c === void 0 ? void 0 : _c.redirectUrl) !== null && _d !== void 0 ? _d : null;
                    break;
            }
            // Append a redirect url if the user is deemed
            // unauthenticated.
            if (type === 'unauthenticated') {
                var setRedirectOnFailedAuth = (_f = (_e = this._config) === null || _e === void 0 ? void 0 : _e.setRedirectOnFailedAuth) !== null && _f !== void 0 ? _f : true;
                if (setRedirectOnFailedAuth && redirectUrl && newUrl) {
                    newUrl += "?redirectUrl=" + redirectUrl;
                }
            }
            // Parse the url if it exists.
            if (this.router && newUrl) {
                return this.router.parseUrl(newUrl);
            }
            // Return false if the user is not allowed.
            return false;
        };
        Auth.prototype.clearAndRedirect = function () {
            var _a, _b;
            // 1. Delete the tokens from the session.
            this.session.clear();
            // 2. Compose the route url.
            var redirectUrl = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.redirectUrl) !== null && _b !== void 0 ? _b : null;
            // 3. Route back if the user provided a redirect url.
            if (this.router && redirectUrl) {
                this.router.navigate([redirectUrl]).then(function (_) { return _; });
            }
        };
        Auth.prototype.setTokens = function (accessToken, refreshToken) {
            // Set the tokens in our session.
            this.session.setTokens(accessToken, refreshToken);
            // We need to update the auto refresh of the refresh token.
            this.handleAutoRefreshing();
        };
        Auth.prototype.handleAutoRefreshing = function () {
            var _this = this;
            var _a, _b, _c, _d;
            var shouldAutoRefresh = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.autoRefresh) !== null && _b !== void 0 ? _b : false;
            if (!shouldAutoRefresh) {
                return;
            }
            var expiresAt = (_d = (_c = this.session.refreshTokenPayload) === null || _c === void 0 ? void 0 : _c.expiresAt) !== null && _d !== void 0 ? _d : null;
            if (expiresAt === null || !this._platform.isBrowser) {
                return;
            }
            var differenceInMilliseconds = expiresAt.getTime() - Date.now();
            var offsetInMilliseconds = 10000; // 10 seconds.
            // We want to start the refresh 10 seconds before it expires.
            var actualTiming = differenceInMilliseconds - offsetInMilliseconds;
            if (actualTiming <= 0) {
                return;
            }
            // We need to cap the timings because if
            // we get large numbers it might cause unwanted results.
            var maxTiming = 1000 * 60 * 60 * 24; // 24 hours.
            var cappedTiming = Math.max(1, Math.min(actualTiming, maxTiming));
            try {
                if (this._refreshHandler !== null) {
                    clearTimeout === null || clearTimeout === void 0 ? void 0 : clearTimeout(this._refreshHandler);
                    this._refreshHandler = null;
                }
                this._refreshHandler = setTimeout === null || setTimeout === void 0 ? void 0 : setTimeout(function () { return _this.autoRefresh(); }, cappedTiming);
            }
            catch (_e) {
                // Just ignore it.
            }
        };
        Auth.prototype.autoRefresh = function () {
            return __awaiter(this, void 0, void 0, function () {
                var _a_1;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            _g.trys.push([0, 2, , 3]);
                            // We just need to wait for it to refresh.
                            return [4 /*yield*/, this.refresh().toPromise()];
                        case 1:
                            // We just need to wait for it to refresh.
                            _g.sent();
                            return [3 /*break*/, 3];
                        case 2:
                            _a_1 = _g.sent();
                            // Something went wrong refreshing, we need to clear.
                            this.clearAndRedirect();
                            return [3 /*break*/, 3];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        Object.defineProperty(Auth.prototype, "router", {
            get: function () {
                return this._injector.get(router.Router);
            },
            enumerable: false,
            configurable: true
        });
        Auth.prototype.getUrl = function (endpoint) {
            return [this._httpAlias, endpoint]
                .filter(function (item) { return !!item; })
                .join('/');
        };
        return Auth;
    }());
    Auth.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Auth, deps: [{ token: i1__namespace.Storage }, { token: AuthMapper }, { token: i0__namespace.Injector }, { token: i3__namespace.Platform }, { token: i4__namespace.HttpClient }, { token: AuthConfig, optional: true }, { token: i6__namespace.TransferState, optional: true }, { token: i7__namespace.HttpConfig, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    Auth.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Auth });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Auth, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: i1__namespace.Storage }, { type: AuthMapper }, { type: i0__namespace.Injector }, { type: i3__namespace.Platform }, { type: i4__namespace.HttpClient }, { type: AuthConfig, decorators: [{
                            type: i0.Optional
                        }] }, { type: i6__namespace.TransferState, decorators: [{
                            type: i0.Optional
                        }] }, { type: i7__namespace.HttpConfig, decorators: [{
                            type: i0.Optional
                        }] }];
        } });

    var BbAuthenticated = /** @class */ (function () {
        function BbAuthenticated(_auth, _template, _viewContainerRef) {
            this._auth = _auth;
            this._template = _template;
            this._viewContainerRef = _viewContainerRef;
        }
        BbAuthenticated.prototype.ngOnInit = function () {
            var _this = this;
            this._subscription = this._auth.user.pipe(operators.map(function (user) { return !!user; }), operators.distinctUntilChanged()).subscribe(function (isAuthenticated) {
                if (!isAuthenticated) {
                    return _this._viewContainerRef.clear();
                }
                _this._viewContainerRef.createEmbeddedView(_this._template);
            });
        };
        BbAuthenticated.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        return BbAuthenticated;
    }());
    BbAuthenticated.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAuthenticated, deps: [{ token: Auth }, { token: i0__namespace.TemplateRef }, { token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbAuthenticated.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbAuthenticated, selector: "[bbAuthenticated]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAuthenticated, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbAuthenticated]'
                    }]
            }], ctorParameters: function () { return [{ type: Auth }, { type: i0__namespace.TemplateRef }, { type: i0__namespace.ViewContainerRef }]; } });

    var BbRole = /** @class */ (function () {
        function BbRole(_auth, _template, _viewContainerRef) {
            this._auth = _auth;
            this._template = _template;
            this._viewContainerRef = _viewContainerRef;
            this.getAllowedRoles = function (value) {
                return Array.isArray(value) ? value : [value];
            };
        }
        BbRole.prototype.ngOnInit = function () {
            var _this = this;
            this._subscription = this._auth.user.pipe(operators.map(function (user) { var _a; return (_a = user === null || user === void 0 ? void 0 : user.role) !== null && _a !== void 0 ? _a : null; }), operators.distinctUntilChanged()).subscribe(function (role) {
                var allowedRoles = _this.getAllowedRoles(_this.bbRole);
                if (!allowedRoles.includes(role)) {
                    return _this._viewContainerRef.clear();
                }
                _this._viewContainerRef.createEmbeddedView(_this._template);
            });
        };
        BbRole.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        return BbRole;
    }());
    BbRole.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbRole, deps: [{ token: Auth }, { token: i0__namespace.TemplateRef }, { token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbRole.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbRole, selector: "[bbRole]", inputs: { bbRole: "bbRole" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbRole, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbRole]'
                    }]
            }], ctorParameters: function () { return [{ type: Auth }, { type: i0__namespace.TemplateRef }, { type: i0__namespace.ViewContainerRef }]; }, propDecorators: { bbRole: [{
                    type: i0.Input
                }] } });

    var Permissions = /** @class */ (function () {
        function Permissions(_auth, _config) {
            var _a, _b;
            this._auth = _auth;
            this._config = _config;
            // Data.
            this._permissions = (_b = (_a = this._config) === null || _a === void 0 ? void 0 : _a.permissions) !== null && _b !== void 0 ? _b : {};
            this._role$ = this._auth.user.pipe(operators.map(function (user) { var _a; return (_a = user === null || user === void 0 ? void 0 : user.role) !== null && _a !== void 0 ? _a : null; }), operators.distinctUntilChanged());
        }
        Permissions.prototype.has = function (value) {
            var _this = this;
            var requiredPermissions = Array.isArray(value)
                ? value
                : [value];
            return this._role$.pipe(operators.map(function (role) {
                var e_1, _f;
                if (role === null || role === undefined) {
                    return false;
                }
                try {
                    for (var requiredPermissions_1 = __values(requiredPermissions), requiredPermissions_1_1 = requiredPermissions_1.next(); !requiredPermissions_1_1.done; requiredPermissions_1_1 = requiredPermissions_1.next()) {
                        var requiredPermission = requiredPermissions_1_1.value;
                        var result = _this.validatePermission(requiredPermission, role);
                        if (!result) {
                            return false;
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (requiredPermissions_1_1 && !requiredPermissions_1_1.done && (_f = requiredPermissions_1.return)) _f.call(requiredPermissions_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return true;
            }));
        };
        Permissions.prototype.validatePermission = function (type, role) {
            var _a, _b, _c, _d, _e;
            var permission = (_b = (_a = this._permissions) === null || _a === void 0 ? void 0 : _a[type]) !== null && _b !== void 0 ? _b : null;
            if (!permission) {
                (_c = console === null || console === void 0 ? void 0 : console.warn) === null || _c === void 0 ? void 0 : _c.call(console, "Permissions: Invalid permission requested \"" + type + "\".");
                return false;
            }
            if ((permission === null || permission === void 0 ? void 0 : permission.length) <= 0) {
                (_d = console === null || console === void 0 ? void 0 : console.warn) === null || _d === void 0 ? void 0 : _d.call(console, "Permissions: No roles were set, please add some roles to this permission.");
                return false;
            }
            // If the permission includes a "*" we allow everyone.
            if (permission.includes('*')) {
                return true;
            }
            // Validate the role against the permissions.
            return (_e = permission === null || permission === void 0 ? void 0 : permission.includes(role)) !== null && _e !== void 0 ? _e : false;
        };
        return Permissions;
    }());
    Permissions.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Permissions, deps: [{ token: Auth }, { token: AuthConfig, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    Permissions.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Permissions });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Permissions, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: Auth }, { type: AuthConfig, decorators: [{
                            type: i0.Optional
                        }] }];
        } });

    var BbPermission = /** @class */ (function () {
        function BbPermission(_permissions, _templateRef, _viewContainerRef) {
            this._permissions = _permissions;
            this._templateRef = _templateRef;
            this._viewContainerRef = _viewContainerRef;
            // Data.
            this._permission$ = new rxjs.BehaviorSubject([]);
            this._valid = false;
            this._elseTemplateRef = null;
            this._thenViewRef = null;
            this._elseViewRef = null;
            this.getAllowedPermissions = function (value) {
                return Array.isArray(value) ? value : [value];
            };
            this.assertTemplate = function (property, templateRef) {
                var isTemplateRefOrNull = !!(!templateRef || templateRef.createEmbeddedView);
                if (!isTemplateRefOrNull) {
                    throw new Error(property + " must be a TemplateRef.");
                }
            };
        }
        Object.defineProperty(BbPermission.prototype, "bbPermission", {
            set: function (value) {
                var permissions = this.getAllowedPermissions(value);
                this._permission$.next(permissions);
                this.updateView();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BbPermission.prototype, "bbPermissionElse", {
            set: function (templateRef) {
                this.assertTemplate('bbPermissionElse', templateRef);
                this._elseTemplateRef = templateRef;
                this.updateView();
            },
            enumerable: false,
            configurable: true
        });
        BbPermission.prototype.ngOnInit = function () {
            var _this = this;
            var check$ = this._permission$.pipe(operators.switchMap(function (permissions) { return _this._permissions.has(permissions); }));
            this._subscription = check$.subscribe(function (valid) {
                _this._valid = valid;
                _this.updateView();
            });
        };
        BbPermission.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        BbPermission.prototype.updateView = function () {
            if (this._valid) {
                if (!this._thenViewRef) {
                    this._viewContainerRef.clear();
                    this._elseViewRef = null;
                    if (this._templateRef) {
                        this._thenViewRef = this._viewContainerRef.createEmbeddedView(this._templateRef);
                    }
                }
            }
            else {
                if (!this._elseViewRef) {
                    this._viewContainerRef.clear();
                    this._thenViewRef = null;
                    if (this._elseTemplateRef) {
                        this._elseViewRef = this._viewContainerRef.createEmbeddedView(this._elseTemplateRef);
                    }
                }
            }
        };
        return BbPermission;
    }());
    BbPermission.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbPermission, deps: [{ token: Permissions }, { token: i0__namespace.TemplateRef }, { token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbPermission.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbPermission, selector: "[bbPermission]", inputs: { bbPermission: "bbPermission", bbPermissionElse: "bbPermissionElse" }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbPermission, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbPermission]'
                    }]
            }], ctorParameters: function () { return [{ type: Permissions }, { type: i0__namespace.TemplateRef }, { type: i0__namespace.ViewContainerRef }]; }, propDecorators: { bbPermission: [{
                    type: i0.Input
                }], bbPermissionElse: [{
                    type: i0.Input
                }] } });

    var BbAnonymousGuard = /** @class */ (function () {
        function BbAnonymousGuard(_auth) {
            this._auth = _auth;
        }
        BbAnonymousGuard.prototype.canActivate = function (_, state) {
            return __awaiter(this, void 0, void 0, function () {
                var isAuthenticated;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this._auth.user.pipe(operators.map(function (user) { return !!user; }), operators.first()).toPromise()];
                        case 1:
                            isAuthenticated = _a.sent();
                            // If the user is not authenticated it can
                            // access the anonymous page.
                            if (!isAuthenticated) {
                                return [2 /*return*/, true];
                            }
                            // Return the user back to the authenticated page.
                            return [2 /*return*/, this._auth.guard('authenticated', state.url)];
                    }
                });
            });
        };
        BbAnonymousGuard.prototype.canActivateChild = function (childRoute, state) {
            return this.canActivate(childRoute, state);
        };
        return BbAnonymousGuard;
    }());
    BbAnonymousGuard.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAnonymousGuard, deps: [{ token: Auth }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    BbAnonymousGuard.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAnonymousGuard, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAnonymousGuard, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return [{ type: Auth }]; } });

    var BbAuthenticatedGuard = /** @class */ (function () {
        function BbAuthenticatedGuard(_auth) {
            this._auth = _auth;
        }
        BbAuthenticatedGuard.prototype.canActivate = function (_, state) {
            return __awaiter(this, void 0, void 0, function () {
                var isAuthenticated;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this._auth.user.pipe(operators.map(function (user) { return !!user; }), operators.first()).toPromise()];
                        case 1:
                            isAuthenticated = _a.sent();
                            // If the user is authenticated it can
                            // access the authenticated page.
                            if (isAuthenticated) {
                                return [2 /*return*/, true];
                            }
                            // The user is not authorized to see that
                            // page so un-authorize him.
                            return [2 /*return*/, this._auth.guard('unauthenticated', state.url)];
                    }
                });
            });
        };
        BbAuthenticatedGuard.prototype.canActivateChild = function (childRoute, state) {
            return this.canActivate(childRoute, state);
        };
        return BbAuthenticatedGuard;
    }());
    BbAuthenticatedGuard.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAuthenticatedGuard, deps: [{ token: Auth }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    BbAuthenticatedGuard.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAuthenticatedGuard, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbAuthenticatedGuard, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return [{ type: Auth }]; } });

    var AuthInterceptor = /** @class */ (function () {
        function AuthInterceptor(_auth, _config) {
            var _this = this;
            this._auth = _auth;
            this._config = _config;
            // Readonly data.
            this._authHeaderString = 'Authorization';
            // Data.
            this.isRefreshing = false;
            this.refreshingAccessToken$ = new rxjs.BehaviorSubject(null);
            this.getAccessToken = function (request) {
                // Get the token based on header.
                if (request.headers.has('Authorization')) {
                    return request.headers.get('Authorization');
                }
                // Return the default access token.
                return _this._auth.session.accessToken;
            };
            this.addAuthorizationHeader = function (request, accessToken) {
                var _c;
                if (accessToken === void 0) { accessToken = null; }
                // Remove auth header when we do not have
                // an access token.
                if (!accessToken) {
                    return request.clone({
                        headers: request.headers.delete(_this._authHeaderString)
                    });
                }
                // Add the auth header to the request.
                return request.clone({
                    setHeaders: (_c = {}, _c[_this._authHeaderString] = _this.getFullAuthorizationHeader(accessToken), _c)
                });
            };
            this.getFullAuthorizationHeader = function (token) {
                var _a, _b;
                var authScheme = (_b = (_a = _this._config) === null || _a === void 0 ? void 0 : _a.scheme) !== null && _b !== void 0 ? _b : 'Bearer';
                return [authScheme, token].join(' ');
            };
        }
        AuthInterceptor.prototype.intercept = function (request, next) {
            var _this = this;
            // 1. Check if the user wants to use the authorization for this request.
            if (!request.context.get(USE_AUTHORIZATION)) {
                return next.handle(request);
            }
            // 2. Compose the new request.
            var accessToken = this.getAccessToken(request);
            var newRequest = this.addAuthorizationHeader(request, accessToken);
            // 3. Handle all errors.
            return next.handle(newRequest).pipe(operators.catchError(function (error) {
                // Handle the HTTP401 error.
                if ((error instanceof i4.HttpErrorResponse || error instanceof i7.HttpError) && (error === null || error === void 0 ? void 0 : error.status) === 401) {
                    return _this.handle401Error(request, next);
                }
                // Just re-throw the parsed error.
                return rxjs.throwError(error);
            }));
        };
        AuthInterceptor.prototype.handle401Error = function (request, next) {
            var _this = this;
            // If already refreshing wait for the refresh token to complete.
            if (this.isRefreshing) {
                return this.refreshingAccessToken$.pipe(operators.filter(function (accessToken) { return accessToken !== null; }), operators.take(1), operators.switchMap(function (accessToken) { return next.handle(_this.addAuthorizationHeader(request, accessToken)); }));
            }
            // Set the refreshing to true.
            this.isRefreshing = true;
            this.refreshingAccessToken$.next(null);
            return this._auth.refresh().pipe(operators.switchMap(function (newAccessToken) {
                if (!newAccessToken) {
                    var error = new Error('No refresh token was available.');
                    return rxjs.throwError(error);
                }
                _this.refreshingAccessToken$.next(newAccessToken);
                return next.handle(_this.addAuthorizationHeader(request, newAccessToken));
            }), operators.catchError(function () { return _this.logoutUser(); }), operators.finalize(function () { return _this.isRefreshing = false; }));
        };
        AuthInterceptor.prototype.logoutUser = function () {
            // Handle the refresh error.
            this._auth.clearAndRedirect();
            // Return null as data.
            return rxjs.of(null);
        };
        return AuthInterceptor;
    }());
    AuthInterceptor.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthInterceptor, deps: [{ token: Auth }, { token: AuthConfig, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    AuthInterceptor.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthInterceptor });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthInterceptor, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: Auth }, { type: AuthConfig, decorators: [{
                            type: i0.Optional
                        }] }];
        } });

    var DECLARATIONS_EXPORTS = [
        BbAuthenticated,
        BbRole,
        BbPermission
    ];
    var AuthModule = /** @class */ (function () {
        function AuthModule() {
        }
        AuthModule.forRoot = function (config) {
            return {
                ngModule: AuthModule,
                providers: [
                    Auth,
                    Permissions,
                    { provide: AuthConfig, useValue: config },
                    { provide: i4.HTTP_INTERCEPTORS, useClass: AuthInterceptor, multi: true },
                    { useFactory: initializeAuth, provide: i0.APP_INITIALIZER, deps: [Auth], multi: true }
                ]
            };
        };
        return AuthModule;
    }());
    AuthModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    AuthModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthModule, declarations: [BbAuthenticated,
            BbRole,
            BbPermission], imports: [i4.HttpClientModule], exports: [BbAuthenticated,
            BbRole,
            BbPermission] });
    AuthModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthModule, providers: [
            { provide: AuthMapper, useClass: AuthMapper }
        ], imports: [[i4.HttpClientModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: AuthModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [i4.HttpClientModule],
                        declarations: __spreadArray([], __read(DECLARATIONS_EXPORTS)),
                        exports: __spreadArray([], __read(DECLARATIONS_EXPORTS)),
                        providers: [
                            { provide: AuthMapper, useClass: AuthMapper }
                        ]
                    }]
            }] });
    function initializeAuth(auth) {
        return auth.initialize();
    }

    /**
     * Generated bundle index. Do not edit.
     */

    exports.Auth = Auth;
    exports.AuthConfig = AuthConfig;
    exports.AuthEmailProvider = AuthEmailProvider;
    exports.AuthMapper = AuthMapper;
    exports.AuthModule = AuthModule;
    exports.AuthSession = AuthSession;
    exports.AuthVerifyProvider = AuthVerifyProvider;
    exports.BbAnonymousGuard = BbAnonymousGuard;
    exports.BbAuthenticated = BbAuthenticated;
    exports.BbAuthenticatedGuard = BbAuthenticatedGuard;
    exports.BbPermission = BbPermission;
    exports.BbRole = BbRole;
    exports.JwtHelper = JwtHelper;
    exports.Permissions = Permissions;
    exports.USE_AUTHORIZATION = USE_AUTHORIZATION;
    exports.initializeAuth = initializeAuth;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bravobit-bb-foundation-auth.umd.js.map
