(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs/operators'), require('rxjs'), require('@angular/core'), require('@angular/animations'), require('@bravobit/bb-foundation'), require('@angular/common'), require('@bravobit/bb-foundation/elements'), require('@bravobit/bb-foundation/localize')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation/dialog', ['exports', 'rxjs/operators', 'rxjs', '@angular/core', '@angular/animations', '@bravobit/bb-foundation', '@angular/common', '@bravobit/bb-foundation/elements', '@bravobit/bb-foundation/localize'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.bravobit = global.bravobit || {}, global.bravobit["bb-foundation"] = global.bravobit["bb-foundation"] || {}, global.bravobit["bb-foundation"].dialog = {}), global.rxjs.operators, global.rxjs, global.ng.core, global.ng.animations, global.bravobit["bb-foundation"], global.ng.common, global.bravobit["bb-foundation"].elements, global.bravobit["bb-foundation"].localize));
})(this, (function (exports, operators, rxjs, i0, animations, i1, i1$1, i6, i8) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i1__namespace$1 = /*#__PURE__*/_interopNamespace(i1$1);
    var i6__namespace = /*#__PURE__*/_interopNamespace(i6);
    var i8__namespace = /*#__PURE__*/_interopNamespace(i8);

    var BbDialogRef = /** @class */ (function () {
        function BbDialogRef() {
            // Data.
            this._afterClosed$ = new rxjs.Subject();
            this._overlayClicked$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogRef.prototype, "afterClosed", {
            get: function () {
                return this._afterClosed$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(BbDialogRef.prototype, "overlayClicked", {
            get: function () {
                return this._overlayClicked$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        BbDialogRef.prototype.onOverlayClicked = function () {
            this._overlayClicked$.next();
        };
        BbDialogRef.prototype.close = function (result) {
            this._afterClosed$.next(result);
        };
        return BbDialogRef;
    }());

    var BbDialogConfig = /** @class */ (function () {
        function BbDialogConfig() {
        }
        return BbDialogConfig;
    }());

    var BbDialogOverlay = /** @class */ (function () {
        function BbDialogOverlay(_elementRef, _changeDetection) {
            this._elementRef = _elementRef;
            this._changeDetection = _changeDetection;
            // Inputs.
            this.animations = true;
            // Outputs.
            this.closeRequested = new i0.EventEmitter();
            // State.
            this._state = 'open';
            this._closed$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogOverlay.prototype, "state", {
            get: function () {
                return this.animations
                    ? this._state
                    : 'none';
            },
            enumerable: false,
            configurable: true
        });
        BbDialogOverlay.prototype.ngAfterViewInit = function () {
            this.listenForClicks();
        };
        BbDialogOverlay.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this._subscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        BbDialogOverlay.prototype.onKeyEvent = function (event) {
            if (event.key === 'Escape') {
                this.closeRequested.emit();
            }
        };
        BbDialogOverlay.prototype.onAnimationDone = function (event) {
            // Check if the dialog is being destroyed.
            if (!['close', 'none'].includes(event.toState)) {
                return;
            }
            this._closed$.next();
            this._closed$.complete();
        };
        BbDialogOverlay.prototype.close = function () {
            // We need change detection to run
            // here else it won't close in all scenario's.
            this._state = 'close';
            this._changeDetection.markForCheck();
            // Listen for the closed trigger.
            return this._closed$.pipe(operators.take(1)).toPromise();
        };
        BbDialogOverlay.prototype.listenForClicks = function () {
            var _this = this;
            if (!this._elementRef || !this._elementRef.nativeElement) {
                return;
            }
            var mouseDown$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mousedown');
            var touchStart$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchstart');
            var start$ = rxjs.race([mouseDown$, touchStart$]);
            var mouseUp$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mouseup');
            var touchEnd$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchend');
            var end$ = rxjs.race([mouseUp$, touchEnd$]);
            this._subscription = start$.pipe(operators.switchMap(function () { return end$; })).subscribe(function () {
                _this.closeRequested.next();
            });
        };
        return BbDialogOverlay;
    }());
    BbDialogOverlay.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogOverlay, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.ChangeDetectorRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogOverlay.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogOverlay, selector: "bb-dialog-overlay", inputs: { animations: "animations" }, outputs: { closeRequested: "closeRequested" }, host: { listeners: { "window:keyup": "onKeyEvent($event)", "@bbDialogAnimation.done": "onAnimationDone($event)" }, properties: { "@bbDialogAnimation": "state" }, classAttribute: "bb-dialog-overlay" }, ngImport: i0__namespace, template: "<div class=\"bb-dialog-overlay-backdrop\"></div>\n\n<ng-content select=\"[bb-dialog-modal]\"></ng-content>\n", styles: [".bb-dialog-overlay,.bb-dialog-overlay-backdrop{top:0;left:0;right:0;bottom:0;display:flex;z-index:1000;position:fixed;flex-direction:column}.bb-dialog-overlay{padding:20px}.bb-dialog-overlay-backdrop{background-color:#00000080}.bb-dialog-overlay-component{z-index:1001;display:block;position:relative}\n"], animations: [
            animations.trigger('bbDialogAnimation', [
                animations.transition('* => none', []),
                animations.transition(':enter, * => open', [
                    animations.group([
                        animations.query('.bb-dialog-overlay-backdrop', [
                            animations.style({ opacity: 0 }),
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 1 }))
                        ]),
                        animations.query('.bb-dialog-modal', [
                            animations.style({ transform: 'scale(0.95)' }),
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ transform: 'scale(1)' }))
                        ])
                    ])
                ]),
                animations.transition(':leave, * => close', [
                    animations.group([
                        animations.query('.bb-dialog-overlay-backdrop', [
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0 }))
                        ]),
                        animations.query('.bb-dialog-modal', [
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0, transform: 'scale(0.95)' }))
                        ])
                    ])
                ])
            ])
        ], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogOverlay, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'bb-dialog-overlay',
                        templateUrl: './dialog-overlay.component.html',
                        styleUrls: ['./dialog-overlay.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-dialog-overlay', '[@bbDialogAnimation]': 'state' },
                        animations: [
                            animations.trigger('bbDialogAnimation', [
                                animations.transition('* => none', []),
                                animations.transition(':enter, * => open', [
                                    animations.group([
                                        animations.query('.bb-dialog-overlay-backdrop', [
                                            animations.style({ opacity: 0 }),
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 1 }))
                                        ]),
                                        animations.query('.bb-dialog-modal', [
                                            animations.style({ transform: 'scale(0.95)' }),
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ transform: 'scale(1)' }))
                                        ])
                                    ])
                                ]),
                                animations.transition(':leave, * => close', [
                                    animations.group([
                                        animations.query('.bb-dialog-overlay-backdrop', [
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0 }))
                                        ]),
                                        animations.query('.bb-dialog-modal', [
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({ opacity: 0, transform: 'scale(0.95)' }))
                                        ])
                                    ])
                                ])
                            ])
                        ]
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.ChangeDetectorRef }]; }, propDecorators: { animations: [{
                    type: i0.Input
                }], closeRequested: [{
                    type: i0.Output
                }], onKeyEvent: [{
                    type: i0.HostListener,
                    args: ['window:keyup', ['$event']]
                }], onAnimationDone: [{
                    type: i0.HostListener,
                    args: ['@bbDialogAnimation.done', ['$event']]
                }] } });

    var BbDialogModal = /** @class */ (function () {
        function BbDialogModal(_patch) {
            this._patch = _patch;
            // Styling.
            this.maxWidth = '420px';
        }
        BbDialogModal.prototype.onOverlayClickedEvent = function (event) {
            event.stopPropagation();
        };
        BbDialogModal.prototype.ngOnInit = function () {
            this._patch.mobileVerticalHeight();
        };
        return BbDialogModal;
    }());
    BbDialogModal.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogModal, deps: [{ token: i1__namespace.Patch }], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogModal.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogModal, selector: "[bb-dialog-modal]", inputs: { maxWidth: "maxWidth" }, host: { attributes: { "role": "dialog" }, listeners: { "click": "onOverlayClickedEvent($event)", "touchstart": "onOverlayClickedEvent($event)", "touchend": "onOverlayClickedEvent($event)", "mouseup": "onOverlayClickedEvent($event)", "mousedown": "onOverlayClickedEvent($event)" }, properties: { "style.max-width": "this.maxWidth" }, classAttribute: "bb-dialog-modal" }, ngImport: i0__namespace, template: "<ng-content select=\"[bb-dialog-header]\">\n\n</ng-content>\n\n<div class=\"bb-dialog-modal-body\">\n    <ng-content></ng-content>\n</div>\n\n<ng-content select=\"[bb-dialog-actions]\">\n\n</ng-content>\n", styles: [".bb-dialog-modal{width:100%;margin:auto;z-index:1001;display:flex;max-width:420px;border-radius:4px;position:relative;flex-direction:column;background-color:#fff;max-height:calc(1vh * 100 - 40px);max-height:calc(var(--vh, 1vh) * 100 - 40px)}.bb-dialog-modal-body{padding:20px;color:#738694;font-size:13px;overflow-y:auto;line-height:1.4;background-color:#f1f3f6}\n"], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogModal, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[bb-dialog-modal]',
                        templateUrl: './dialog-modal.component.html',
                        styleUrls: ['./dialog-modal.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dialog-modal',
                            'role': 'dialog'
                        }
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.Patch }]; }, propDecorators: { maxWidth: [{
                    type: i0.HostBinding,
                    args: ['style.max-width']
                }, {
                    type: i0.Input
                }], onOverlayClickedEvent: [{
                    type: i0.HostListener,
                    args: ['click', ['$event']]
                }, {
                    type: i0.HostListener,
                    args: ['touchstart', ['$event']]
                }, {
                    type: i0.HostListener,
                    args: ['touchend', ['$event']]
                }, {
                    type: i0.HostListener,
                    args: ['mouseup', ['$event']]
                }, {
                    type: i0.HostListener,
                    args: ['mousedown', ['$event']]
                }] } });

    var BbDialogHeader = /** @class */ (function () {
        function BbDialogHeader() {
            // Inputs.
            this.iconName = null;
            this.iconColor = 'black';
            // Outputs.
            this.closeRequested = new i0.EventEmitter();
        }
        return BbDialogHeader;
    }());
    BbDialogHeader.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogHeader, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogHeader.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogHeader, selector: "[bb-dialog-header]", inputs: { iconName: "iconName", iconColor: "iconColor" }, outputs: { closeRequested: "closeRequested" }, host: { classAttribute: "bb-dialog-header" }, ngImport: i0__namespace, template: "<div class=\"bb-dialog-header-row\">\n    <div *ngIf=\"iconName as icon\"\n         [style.color]=\"iconColor\"\n         class=\"bb-dialog-header-icon\">\n        <i class=\"material-icons\">{{ icon }}</i>\n    </div>\n\n    <div class=\"bb-dialog-header-content\">\n        <ng-content></ng-content>\n    </div>\n\n    <button *ngIf=\"closeRequested?.observers?.length > 0\"\n            (click)=\"closeRequested?.emit()\"\n            type=\"button\"\n            class=\"bb-dialog-header-close\">\n    </button>\n</div>\n\n<nav class=\"bb-dialog-header-navigation\">\n    <ng-content select=\"[bb-dialog-link]\"></ng-content>\n</nav>\n", styles: [".bb-dialog-header{display:flex;min-height:60px;flex-direction:column;justify-content:center;background-color:#fff;border-top-left-radius:4px;border-top-right-radius:4px;border-bottom:1px solid #d8d8d8}.bb-dialog-header .bb-dialog-header-content,.bb-dialog-header .bb-dialog-header-content h1{max-width:100%;font-size:20px;font-weight:500;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.bb-dialog-header-row,.bb-dialog-header-navigation{width:100%;display:flex;align-items:center}.bb-dialog-header-row{padding:10px 20px}.bb-dialog-header-navigation{width:100%;padding:0 20px;overflow-x:auto;white-space:nowrap}.bb-dialog-header-navigation:empty{margin:0;height:0;padding:0;visibility:hidden}.bb-dialog-header-content{flex:1}.bb-dialog-header-icon{width:40px;height:40px;display:flex;min-width:40px;overflow:hidden;min-height:40px;margin-right:10px;border-radius:50%;position:relative;align-items:center;justify-content:center}.bb-dialog-header-icon:after{top:0;left:0;right:0;bottom:0;content:\"\";opacity:.14;position:absolute;background-color:currentColor}.bb-dialog-header-close{width:32px;height:32px;border:none;min-width:32px;min-height:32px;overflow:hidden;margin-left:10px;border-radius:4px;position:relative;margin-right:-10px;display:inline-block;background-color:transparent}.bb-dialog-header-close:before,.bb-dialog-header-close:after{top:50%;left:20%;width:60%;height:2px;content:\"\";margin-top:-1px;position:absolute;background-color:#a2a9ba}.bb-dialog-header-close:before{transform:rotate(45deg)}.bb-dialog-header-close:after{transform:rotate(-45deg)}.bb-dialog-header-close:hover{background-color:#00000014}.bb-dialog-header-close:focus{background-color:#0000001f}.bb-dialog-header-close:active{background-color:#00000029}\n"], directives: [{ type: i1__namespace$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogHeader, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[bb-dialog-header]',
                        templateUrl: './dialog-header.component.html',
                        styleUrls: ['./dialog-header.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-dialog-header' }
                    }]
            }], propDecorators: { iconName: [{
                    type: i0.Input
                }], iconColor: [{
                    type: i0.Input
                }], closeRequested: [{
                    type: i0.Output
                }] } });

    var BbDialogLink = /** @class */ (function () {
        function BbDialogLink() {
        }
        return BbDialogLink;
    }());
    BbDialogLink.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogLink, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogLink.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogLink, selector: "[bb-dialog-link]", host: { classAttribute: "bb-dialog-link" }, ngImport: i0__namespace, template: "<ng-content></ng-content>\n", styles: [".bb-dialog-link{height:30px;display:flex;font-size:16px;font-weight:500;white-space:nowrap;align-items:center;color:#6b5c5c!important;background-color:transparent;text-decoration:none!important;border-bottom:2px solid transparent}.bb-dialog-link+.bb-dialog-link{margin-left:10px}.bb-dialog-link:hover:not(.disabled){border-bottom:2px solid rgba(117,119,148,.2)}.bb-dialog-link.active,.bb-dialog-link.active:hover{color:#5b53ff!important;border-bottom-color:#5b53ff}.bb-dialog-link.disabled,.bb-dialog-link.disabled:focus,.bb-dialog-link.disabled:hover,.bb-dialog-link.disabled:active{opacity:.4;cursor:default;box-shadow:none}\n"], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogLink, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[bb-dialog-link]',
                        templateUrl: './dialog-link.component.html',
                        styleUrls: ['./dialog-link.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-dialog-link' }
                    }]
            }] });

    var BbDialogActions = /** @class */ (function () {
        function BbDialogActions() {
        }
        return BbDialogActions;
    }());
    BbDialogActions.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogActions, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogActions.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogActions, selector: "[bb-dialog-actions]", host: { classAttribute: "bb-dialog-actions" }, ngImport: i0__namespace, template: "<bb-form-group class=\"end\">\n    <ng-content></ng-content>\n</bb-form-group>\n", styles: [".bb-dialog-actions{padding:20px;display:block;background-color:#fff;border-top:1px solid #d8d8d8;border-bottom-left-radius:4px;border-bottom-right-radius:4px}\n"], components: [{ type: i6__namespace.BbFormGroup, selector: "bb-form-group", inputs: ["grouped"] }], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogActions, decorators: [{
                type: i0.Component,
                args: [{
                        selector: '[bb-dialog-actions]',
                        templateUrl: './dialog-actions.component.html',
                        styleUrls: ['./dialog-actions.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-dialog-actions' }
                    }]
            }] });

    var BbDialogInsertion = /** @class */ (function () {
        function BbDialogInsertion(viewContainerRef) {
            this.viewContainerRef = viewContainerRef;
        }
        return BbDialogInsertion;
    }());
    BbDialogInsertion.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogInsertion, deps: [{ token: i0__namespace.ViewContainerRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    BbDialogInsertion.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogInsertion, selector: "[bbDialogInsertion]", ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogInsertion, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[bbDialogInsertion]'
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ViewContainerRef }]; } });

    var BbDialogContainer = /** @class */ (function () {
        function BbDialogContainer(_elementRef, _changeDetection, _componentFactoryResolver) {
            this._elementRef = _elementRef;
            this._changeDetection = _changeDetection;
            this._componentFactoryResolver = _componentFactoryResolver;
            // Data.
            this.componentRef = null;
            this.childComponentType = null;
            // State.
            this.overlayClicked$ = new rxjs.Subject();
        }
        Object.defineProperty(BbDialogContainer.prototype, "onOverlayClicked", {
            get: function () {
                return this.overlayClicked$.pipe(operators.take(1));
            },
            enumerable: false,
            configurable: true
        });
        BbDialogContainer.prototype.ngAfterViewInit = function () {
            // Load the child component.
            this.loadChildComponent(this.childComponentType);
            // Listen for mouse click on the dialog container.
            this.listenForClicks();
            // Detect changes to notify change detection.
            this._changeDetection.detectChanges();
        };
        BbDialogContainer.prototype.ngOnDestroy = function () {
            this._subscription && this._subscription.unsubscribe();
        };
        BbDialogContainer.prototype.onAnimationDone = function (event) {
            // Check if the dialog is being destroyed.
            if (event.toState !== 'void') {
                return;
            }
            // Destroy the ref if it exists.
            this.componentRef && this.componentRef.destroy();
        };
        BbDialogContainer.prototype.listenForClicks = function () {
            var _this = this;
            if (!this._elementRef || !this._elementRef.nativeElement) {
                return;
            }
            var mouseDown$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mousedown');
            var touchStart$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchstart');
            var start$ = rxjs.race([mouseDown$, touchStart$]);
            var mouseUp$ = rxjs.fromEvent(this._elementRef.nativeElement, 'mouseup');
            var touchEnd$ = rxjs.fromEvent(this._elementRef.nativeElement, 'touchend');
            var end$ = rxjs.race([mouseUp$, touchEnd$]);
            this._subscription = start$.pipe(operators.switchMap(function () { return end$; })).subscribe(function () {
                _this.overlayClicked$.next();
            });
        };
        BbDialogContainer.prototype.loadChildComponent = function (componentType) {
            // Resolve the component.
            var componentFactory = this._componentFactoryResolver.resolveComponentFactory(componentType);
            // Get the view container ref and clear it.
            var viewContainerRef = this.insertion.viewContainerRef;
            viewContainerRef.clear();
            // Create an instance of the component.
            this.componentRef = viewContainerRef.createComponent(componentFactory);
        };
        return BbDialogContainer;
    }());
    BbDialogContainer.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogContainer, deps: [{ token: i0__namespace.ElementRef }, { token: i0__namespace.ChangeDetectorRef }, { token: i0__namespace.ComponentFactoryResolver }], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogContainer.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogContainer, selector: "bb-dialog-container", host: { listeners: { "@bbDialogAnimation.done": "onAnimationDone($event)" }, properties: { "@bbDialogAnimation": "true" }, classAttribute: "bb-dialog-container" }, viewQueries: [{ propertyName: "insertion", first: true, predicate: BbDialogInsertion, descendants: true, static: true }], ngImport: i0__namespace, template: "<div class=\"bb-dialog-container-backdrop\">\n</div>\n\n<div class=\"bb-dialog-container-component\">\n    <ng-container bbDialogInsertion>\n    </ng-container>\n</div>\n", styles: [".bb-dialog-container,.bb-dialog-container-backdrop{top:0;left:0;right:0;bottom:0;z-index:1000;position:fixed}.bb-dialog-container{display:flex}.bb-dialog-container-backdrop{background-color:#00000080}.bb-dialog-container-component{width:100%;margin:auto;padding:20px;z-index:1001;display:block}\n"], directives: [{ type: BbDialogInsertion, selector: "[bbDialogInsertion]" }], animations: [
            animations.trigger('bbDialogAnimation', [
                animations.transition(':enter', [
                    animations.group([
                        animations.query('.bb-dialog-container-backdrop', [
                            animations.style({
                                opacity: 0
                            }),
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                opacity: 1
                            }))
                        ]),
                        animations.query('.bb-dialog-container-component', [
                            animations.style({
                                transform: 'scale(0.95)'
                            }),
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                transform: 'scale(1)'
                            }))
                        ])
                    ])
                ]),
                animations.transition(':leave', [
                    animations.group([
                        animations.query('.bb-dialog-container-backdrop', [
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                opacity: 0
                            }))
                        ]),
                        animations.query('.bb-dialog-container-component', [
                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                opacity: 0,
                                transform: 'scale(0.95)'
                            }))
                        ])
                    ])
                ])
            ])
        ], changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogContainer, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'bb-dialog-container',
                        templateUrl: './dialog-container.component.html',
                        styleUrls: ['./dialog-container.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        host: { 'class': 'bb-dialog-container', '[@bbDialogAnimation]': 'true' },
                        preserveWhitespaces: false,
                        animations: [
                            animations.trigger('bbDialogAnimation', [
                                animations.transition(':enter', [
                                    animations.group([
                                        animations.query('.bb-dialog-container-backdrop', [
                                            animations.style({
                                                opacity: 0
                                            }),
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                                opacity: 1
                                            }))
                                        ]),
                                        animations.query('.bb-dialog-container-component', [
                                            animations.style({
                                                transform: 'scale(0.95)'
                                            }),
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                                transform: 'scale(1)'
                                            }))
                                        ])
                                    ])
                                ]),
                                animations.transition(':leave', [
                                    animations.group([
                                        animations.query('.bb-dialog-container-backdrop', [
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                                opacity: 0
                                            }))
                                        ]),
                                        animations.query('.bb-dialog-container-component', [
                                            animations.animate('150ms cubic-bezier(0, 0, 0.2, 1)', animations.style({
                                                opacity: 0,
                                                transform: 'scale(0.95)'
                                            }))
                                        ])
                                    ])
                                ])
                            ])
                        ]
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }, { type: i0__namespace.ChangeDetectorRef }, { type: i0__namespace.ComponentFactoryResolver }]; }, propDecorators: { insertion: [{
                    type: i0.ViewChild,
                    args: [BbDialogInsertion, { static: true }]
                }], onAnimationDone: [{
                    type: i0.HostListener,
                    args: ['@bbDialogAnimation.done', ['$event']]
                }] } });

    var nextUniqueId = 0;
    var BbDialogConfirm = /** @class */ (function () {
        function BbDialogConfirm(config, dialogRef) {
            this.config = config;
            this.dialogRef = dialogRef;
            // Id.
            this.dialogId = "bb-dialog-confirm-" + nextUniqueId++;
        }
        BbDialogConfirm.prototype.ngAfterViewInit = function () {
            // Initial focus the button.
            this.confirmButton.focus();
        };
        BbDialogConfirm.prototype.onClose = function (result) {
            this.dialogRef.close(result);
        };
        return BbDialogConfirm;
    }());
    BbDialogConfirm.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogConfirm, deps: [{ token: BbDialogConfig }, { token: BbDialogRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
    BbDialogConfirm.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.11", type: BbDialogConfirm, selector: "bb-dialog-confirm", host: { classAttribute: "bb-dialog-confirm" }, viewQueries: [{ propertyName: "confirmButton", first: true, predicate: ["confirm"], descendants: true, read: i6.BbButton }], ngImport: i0__namespace, template: "<div [attr.aria-labelledby]=\"dialogId\"\n     bb-dialog-modal\n     bbFocusTrap>\n    <header bb-dialog-header>\n        <h1 *ngIf=\"config?.data?.title as title\"\n            [id]=\"dialogId\">\n            {{ title | bbLocalize:{optional: true} }}\n        </h1>\n    </header>\n\n    <p>\n        {{ config?.data?.description | bbLocalize:{optional: true} }}\n    </p>\n\n    <footer bb-dialog-actions>\n        <button *ngIf=\"config?.data?.cancelButtonText as cancelButtonText\"\n                (click)=\"onClose(false)\"\n                bb-button\n                type=\"button\">\n            {{ cancelButtonText | bbLocalize:{optional: true} }}\n        </button>\n        <button #confirm\n                *ngIf=\"config?.data?.confirmButtonText as confirmButtonText\"\n                (click)=\"onClose(true)\"\n                bb-button\n                type=\"button\"\n                class=\"destructive\">\n            {{ confirmButtonText | bbLocalize:{optional: true} }}\n        </button>\n    </footer>\n</div>\n", styles: [".bb-dialog-confirm{display:block}\n"], components: [{ type: BbDialogModal, selector: "[bb-dialog-modal]", inputs: ["maxWidth"] }, { type: BbDialogHeader, selector: "[bb-dialog-header]", inputs: ["iconName", "iconColor"], outputs: ["closeRequested"] }, { type: BbDialogActions, selector: "[bb-dialog-actions]" }, { type: i6__namespace.BbButton, selector: "button[bb-button]", inputs: ["disabled", "loading"], exportAs: ["bbButton"] }], directives: [{ type: i6__namespace.BbFocusTrap, selector: "[bbFocusTrap]" }, { type: i1__namespace$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], pipes: { "bbLocalize": i8__namespace.BbLocalize }, changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: BbDialogConfirm, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'bb-dialog-confirm',
                        templateUrl: './dialog-confirm.component.html',
                        styleUrls: ['./dialog-confirm.component.scss'],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: { 'class': 'bb-dialog-confirm' }
                    }]
            }], ctorParameters: function () { return [{ type: BbDialogConfig }, { type: BbDialogRef }]; }, propDecorators: { confirmButton: [{
                    type: i0.ViewChild,
                    args: ['confirm', { read: i6.BbButton }]
                }] } });

    var BbDialogInjector = /** @class */ (function () {
        function BbDialogInjector(_parentInjector, _additionalTokens) {
            this._parentInjector = _parentInjector;
            this._additionalTokens = _additionalTokens;
        }
        BbDialogInjector.prototype.get = function (token, notFoundValue) {
            // First check if the additional token
            // contains the token.
            var value = this._additionalTokens.get(token);
            // If that value exists return it.
            if (value) {
                return value;
            }
            // Else query the parent injector.
            return this._parentInjector.get(token, notFoundValue);
        };
        return BbDialogInjector;
    }());

    var Dialog = /** @class */ (function () {
        function Dialog(_injector, _applicationRef, _componentFactoryResolver) {
            this._injector = _injector;
            this._applicationRef = _applicationRef;
            this._componentFactoryResolver = _componentFactoryResolver;
        }
        Dialog.prototype.open = function (componentType, config) {
            return this.createDialog(componentType, config);
        };
        Dialog.prototype.confirm = function (title, description, options) {
            if (options === void 0) { options = {}; }
            return this.open(BbDialogConfirm, {
                data: {
                    title: title,
                    description: description,
                    cancelButtonText: options.cancelButtonText || 'dialog.default_cancel_button',
                    confirmButtonText: options.confirmButtonText || 'dialog.default_confirm_button'
                }
            });
        };
        Dialog.prototype.createDialog = function (componentType, config) {
            var _this = this;
            // Create a reference.
            var dialogRef = new BbDialogRef();
            // Create a map with the config.
            var map = new WeakMap();
            map.set(BbDialogConfig, config);
            map.set(BbDialogRef, dialogRef);
            // Create a custom injector.
            var dialogInjector = new BbDialogInjector(this._injector, map);
            // Resolve the dialog component reference.
            var dialogComponentRef = this._componentFactoryResolver
                .resolveComponentFactory(BbDialogContainer)
                .create(dialogInjector);
            // Attach the host view to the application.
            this._applicationRef.attachView(dialogComponentRef.hostView);
            try {
                // Remove the current focus.
                var activeElement = document.activeElement;
                activeElement.blur();
                // Append the element to the DOM.
                document.body.appendChild(dialogComponentRef.location.nativeElement);
            }
            catch (_a) {
                // Don't do anything, because it must've failed.
            }
            // Set the child component type on the component.
            dialogComponentRef.instance.childComponentType = componentType;
            dialogComponentRef.instance.onOverlayClicked.subscribe(function () { return dialogRef.onOverlayClicked(); });
            // Listen for close events.
            dialogRef.afterClosed.subscribe(function () { return _this.deleteDialog(dialogComponentRef); });
            // Return the reference.
            return dialogRef;
        };
        Dialog.prototype.deleteDialog = function (dialogComponentRef) {
            // Only continue if the dialog component ref exists.
            if (!dialogComponentRef) {
                return;
            }
            // Detach the dialog.
            this._applicationRef.detachView(dialogComponentRef.hostView);
            // Destroy the dialog.
            dialogComponentRef.destroy();
            dialogComponentRef = null;
        };
        return Dialog;
    }());
    Dialog.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Dialog, deps: [{ token: i0__namespace.Injector }, { token: i0__namespace.ApplicationRef }, { token: i0__namespace.ComponentFactoryResolver }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    Dialog.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Dialog });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: Dialog, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () { return [{ type: i0__namespace.Injector }, { type: i0__namespace.ApplicationRef }, { type: i0__namespace.ComponentFactoryResolver }]; } });

    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        DialogModule.forRoot = function () {
            return {
                ngModule: DialogModule,
                providers: [Dialog]
            };
        };
        return DialogModule;
    }());
    DialogModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DialogModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    DialogModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DialogModule, declarations: [BbDialogContainer,
            BbDialogOverlay,
            BbDialogModal,
            BbDialogHeader,
            BbDialogLink,
            BbDialogActions,
            BbDialogConfirm,
            BbDialogInsertion], imports: [i1$1.CommonModule,
            i8.LocalizeModule,
            i6.ElementsModule], exports: [BbDialogOverlay,
            BbDialogModal,
            BbDialogHeader,
            BbDialogLink,
            BbDialogActions] });
    DialogModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DialogModule, imports: [[
                i1$1.CommonModule,
                i8.LocalizeModule,
                i6.ElementsModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.11", ngImport: i0__namespace, type: DialogModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        imports: [
                            i1$1.CommonModule,
                            i8.LocalizeModule,
                            i6.ElementsModule
                        ],
                        declarations: [
                            BbDialogContainer,
                            BbDialogOverlay,
                            BbDialogModal,
                            BbDialogHeader,
                            BbDialogLink,
                            BbDialogActions,
                            BbDialogConfirm,
                            BbDialogInsertion
                        ],
                        entryComponents: [
                            BbDialogContainer,
                            BbDialogConfirm
                        ],
                        exports: [
                            BbDialogOverlay,
                            BbDialogModal,
                            BbDialogHeader,
                            BbDialogLink,
                            BbDialogActions
                        ]
                    }]
            }] });

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BbDialogActions = BbDialogActions;
    exports.BbDialogConfig = BbDialogConfig;
    exports.BbDialogHeader = BbDialogHeader;
    exports.BbDialogLink = BbDialogLink;
    exports.BbDialogModal = BbDialogModal;
    exports.BbDialogOverlay = BbDialogOverlay;
    exports.BbDialogRef = BbDialogRef;
    exports.Dialog = Dialog;
    exports.DialogModule = DialogModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=bravobit-bb-foundation-dialog.umd.js.map
